=== modified file 'DBUS-API'
--- DBUS-API	2012-01-15 20:27:28 +0000
+++ DBUS-API	2012-01-01 04:02:00 +0000
@@ -93,11 +93,10 @@
    | Interval (a)            | t    | Read/Write | interval            |
    | LastApprovalRequest (g) | s    | Read       | N/A                 |
    | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
-   | LastCheckerStatus (i)   | n    | Read       | N/A                 |
-   | LastEnabled (j)         | s    | Read       | N/A                 |
+   | LastEnabled (i)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (k)              | ay   | Write      | secret (or secfile) |
+   | Secret (j)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -125,13 +124,10 @@
       always use an empty string when setting this property, to allow
       for possible future expansion.
    
-   i) The exit status of the last checker, -1 if it did not exit
-      cleanly, -2 if a checker has not yet returned.
-   
-   j) The date and time this client was last enabled, as an RFC 3339
+   i) The date and time this client was last enabled, as an RFC 3339
       string, or an empty string if this has not happened.
    
-   k) A raw byte array, not hexadecimal digits.
+   j) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -156,6 +152,9 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
+*** NewRequest(s: IPAddress)
+    A client at IPAdress has requested its secret.
+
 * Copyright
 
     Copyright © 2010-2012 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2012-01-15 21:07:44 +0000
+++ Makefile	2011-12-21 00:33:12 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.3
+version=1.4.1
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -319,8 +319,6 @@
 		> $(MANDIR)/man5/mandos.conf.5.gz
 	gzip --best --to-stdout mandos-clients.conf.5 \
 		> $(MANDIR)/man5/mandos-clients.conf.5.gz
-	gzip --best --to-stdout intro.8mandos \
-		> $(MANDIR)/man8/intro.8mandos.gz
 
 install-client-nokey: all doc
 	install --directory $(PREFIX)/lib/mandos $(CONFDIR)

=== modified file 'NEWS'
--- NEWS	2012-01-15 21:07:44 +0000
+++ NEWS	2011-10-15 16:48:03 +0000
@@ -1,42 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.3 (2012-01-15)
-* Server
-** Add D-Bus property se.recompile.Client.LastCheckerStatus and use it
-   in mandos-monitor.
-* Client
-** Fix bugs in the example "bridge" network hook.
-
-Version 1.5.2 (2012-01-08)
-* Server
-** Removed D-Bus signal se.recompile.Mandos.NewRequest() added in
-   1.5.0.  It was buggy and was of questionable utility.
-
-Version 1.5.1 (2012-01-01)
-* Server
-** Include intro(8mandos) manual page, missing since migration from
-   README file in version 1.4.0.
-
-Version 1.5.0 (2012-01-01)
-* Client
-** Network hooks.  The Mandos client can now run custom scripts to take
-   up a network interface before the client is run.  Three example
-   scripts are provided: "wireless", "openvpn", and "bridge".
-   To facilitate this, the client now prefers network interfaces which
-   are up (if any) over all other interfaces.
-* Server
-** Persistent state.  Client state is now saved between server
-   restarts.
-** clients.conf file can now contain "enabled" setting for clients.
-** Bug fix: Fix rare crash bug.
-** Bug fix: Send corrent D-Bus type in PropertyChanged for
-   "ApprovalDelay", "ApprovalDuration", "Timeout", and
-   "ExtendedTimeout".
-** mandos-ctl: Bare numbers as arguments are taken to be milliseconds.
-** Bug fix: mandos-ctl --secret option now works.
-** New D-Bus signal: se.recompile.Mandos.NewRequest(s).
-
 Version 1.4.1 (2011-10-15)
 * Server
 ** Make D-Bus properties settable again, and handle checkers

=== modified file 'README'
--- README	2012-01-01 20:45:53 +0000
+++ README	2011-10-05 16:00:56 +0000
@@ -1,8 +1,7 @@
 Please see: http://www.recompile.se/mandos/man/intro.8mandos
 
 This information previously in this file has been moved to the
-intro(8mandos) manual page.  Go to the above URL, or install the
-Mandos server and run this command:
+intro(8mandos) manual page.  Go to the above URL, or run this command:
 
 	man 8mandos intro
 

=== modified file 'TODO'
--- TODO	2012-05-01 20:48:00 +0000
+++ TODO	2012-01-01 04:02:00 +0000
@@ -11,7 +11,6 @@
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
 ** TODO [#B] Prefer /run/tmp over /tmp, if it exists
-** TODO [#B] Use in_port_t instead of uint16_t for port numbers.
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -78,11 +77,6 @@
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
 ** TODO Save state periodically to recover better from hard shutdowns
-** TODO CheckerCompleted method, deprecate CheckedOK
-** TODO Secret Service API?
-   http://standards.freedesktop.org/secret-service/
-** TODO [[info:python:What's%20New%20in%20Python%202%206][What's New in Python 2.6]]
-*** Start at [[info:python:PEP%203101%20Advanced%20String%20Formatting][PEP 3101 Advanced String Formatting]]
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'common.ent'
--- common.ent	2012-01-15 21:07:44 +0000
+++ common.ent	2011-10-15 16:48:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.3">
+<!ENTITY version "1.4.1">

=== modified file 'debian/changelog'
--- debian/changelog	2012-02-21 21:20:12 +0000
+++ debian/changelog	2011-10-15 16:48:03 +0000
@@ -1,47 +1,3 @@
-mandos (1.5.3-1.1) unstable; urgency=low
-
-  * Non-maintainer upload.
-  * Fix "mandos FTBFS on buildds": add build-dependency on locales-all and
-    pass LC_ALL to dh_auto_build to make sure we have and use the en_US.UTF-8
-    locale for manpage creation.
-    (Closes: #656178)
-
- -- gregor herrmann <gregoa@debian.org>  Tue, 31 Jan 2012 17:56:05 +0100
-
-mandos (1.5.3-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 15 Jan 2012 22:05:54 +0100
-
-mandos (1.5.2-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 08 Jan 2012 11:17:20 +0100
-
-mandos (1.5.1-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 21:53:31 +0100
-
-mandos (1.5.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (mandos-client/Depends): Added "initramfs-tools".
-  * debian/mandos-client.README.Debian: Corrected mail address and adjust
-                                        wording.
-  * debian/rules (binary-common): Exclude new nework-hooks.d directory
-                                  from dh_fixperms.
-  * debian/mandos-client.README.Debian: Document network hook facility.
-  * debian/mandos-client.docs (network-hooks.d): Added.
-  * debian/mandos.dirs (var/lib/mandos): Added.
-  * debian/mandos.postinst: Fix ownership of /var/lib/mandos.
-  * debian/control (mandos/Depends): Added "python-gnupginterface".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 05:58:11 +0100
-
 mandos (1.4.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2012-02-21 21:20:12 +0000
+++ debian/control	2011-12-21 17:09:12 +0000
@@ -6,7 +6,7 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man, locales-all
+	pkg-config, man
 Standards-Version: 3.9.2
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files

=== modified file 'debian/rules'
--- debian/rules	2012-02-21 21:20:12 +0000
+++ debian/rules	2012-01-01 04:02:00 +0000
@@ -38,12 +38,12 @@
 
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp
-	LC_ALL=en_US.utf8 dh_auto_build -- all doc
+	dh_auto_build -- all doc
 	touch $@
 
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
-	LC_ALL=en_US.UTF-8 dh_auto_build -- doc
+	dh_auto_build -- doc
 	touch $@
 
 clean:

=== modified file 'mandos'
--- mandos	2012-05-03 19:06:02 +0000
+++ mandos	2012-01-01 04:02:00 +0000
@@ -65,7 +65,6 @@
 import types
 import binascii
 import tempfile
-import itertools
 
 import dbus
 import dbus.service
@@ -86,7 +85,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.3"
+version = "1.4.1"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -176,7 +175,7 @@
     
     def encrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--symmetric'],
                                       create_fhs=['stdin', 'stdout'],
@@ -193,12 +192,12 @@
     
     def decrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--decrypt'],
                                       create_fhs=['stdin', 'stdout'],
                                       attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
+                with contextlib.closing(proc.handles['stdin'] ) as f:
                     f.write(data)
                 with contextlib.closing(proc.handles['stdout']) as f:
                     decrypted_plaintext = f.read()
@@ -277,7 +276,7 @@
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            logger.critical("D-Bus Exception", exc_info=error)
+            logger.critical("DBusException: %s", error)
             self.cleanup()
             os._exit(1)
         self.rename_count += 1
@@ -322,8 +321,8 @@
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
                             unicode(error))
-            raise AvahiGroupError("State changed: {0!s}"
-                                  .format(error))
+            raise AvahiGroupError("State changed: %s"
+                                  % unicode(error))
     def cleanup(self):
         """Derived from the Avahi example code"""
         if self.group is not None:
@@ -375,9 +374,9 @@
         """Add the new name to the syslog messages"""
         ret = AvahiService.rename(self)
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({0}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(self.name)))
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         return ret
 
 def timedelta_to_milliseconds(td):
@@ -416,14 +415,14 @@
     last_checked_ok: datetime.datetime(); (UTC) or None
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
-                         checker, -2 means no checker completed yet.
+                         checker, or None.
     last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
-    extended_timeout:   extra long timeout when secret has been sent
+    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
     expires:    datetime.datetime(); time (UTC) when a client will be
                 disabled, or None
@@ -489,8 +488,8 @@
                           "rb") as secfile:
                     client["secret"] = secfile.read()
             else:
-                raise TypeError("No secret or secfile for section {0}"
-                                .format(section))
+                raise TypeError("No secret or secfile for section %s"
+                                % section)
             client["timeout"] = string_to_delta(section["timeout"])
             client["extended_timeout"] = string_to_delta(
                 section["extended_timeout"])
@@ -502,7 +501,7 @@
             client["checker_command"] = section["checker"]
             client["last_approval_request"] = None
             client["last_checked_ok"] = None
-            client["last_checker_status"] = -2
+            client["last_checker_status"] = None
         
         return settings
         
@@ -627,16 +626,15 @@
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self):
-        """Assert that the client has been seen, alive and well."""
-        self.last_checked_ok = datetime.datetime.utcnow()
-        self.last_checker_status = 0
-        self.bump_timeout()
-    
-    def bump_timeout(self, timeout=None):
-        """Bump up the timeout for this client."""
+    def checked_ok(self, timeout=None):
+        """Bump up the timeout for this client.
+        
+        This should only be called when the client has been seen,
+        alive and well.
+        """
         if timeout is None:
             timeout = self.timeout
+        self.last_checked_ok = datetime.datetime.utcnow()
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
@@ -693,8 +691,8 @@
                 try:
                     command = self.checker_command % escaped_attrs
                 except TypeError as error:
-                    logger.error('Could not format string "%s"',
-                                 self.checker_command, exc_info=error)
+                    logger.error('Could not format string "%s":'
+                                 ' %s', self.checker_command, error)
                     return True # Try again later
             self.current_checker_command = command
             try:
@@ -718,8 +716,8 @@
                     gobject.source_remove(self.checker_callback_tag)
                     self.checker_callback(pid, status, command)
             except OSError as error:
-                logger.error("Failed to start subprocess",
-                             exc_info=error)
+                logger.error("Failed to start subprocess: %s",
+                             error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
     
@@ -732,10 +730,10 @@
             return
         logger.debug("Stopping checker for %(name)s", vars(self))
         try:
-            self.checker.terminate()
+            os.kill(self.checker.pid, signal.SIGTERM)
             #time.sleep(0.5)
             #if self.checker.poll() is None:
-            #    self.checker.kill()
+            #    os.kill(self.checker.pid, signal.SIGKILL)
         except OSError as error:
             if error.errno != errno.ESRCH: # No such process
                 raise
@@ -758,7 +756,7 @@
     # "Set" method, so we fail early here:
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature {0!r}".format(signature))
+                         " signature %r" % signature)
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -772,43 +770,6 @@
     return decorator
 
 
-def dbus_interface_annotations(dbus_interface):
-    """Decorator for marking functions returning interface annotations.
-    
-    Usage:
-    
-    @dbus_interface_annotations("org.example.Interface")
-    def _foo(self):  # Function name does not matter
-        return {"org.freedesktop.DBus.Deprecated": "true",
-                "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                    "false"}
-    """
-    def decorator(func):
-        func._dbus_is_interface = True
-        func._dbus_interface = dbus_interface
-        func._dbus_name = dbus_interface
-        return func
-    return decorator
-
-
-def dbus_annotations(annotations):
-    """Decorator to annotate D-Bus methods, signals or properties
-    Usage:
-    
-    @dbus_service_property("org.example.Interface", signature="b",
-                           access="r")
-    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
-                        "org.freedesktop.DBus.Property."
-                        "EmitsChangedSignal": "false"})
-    def Property_dbus_property(self):
-        return dbus.Boolean(False)
-    """
-    def decorator(func):
-        func._dbus_annotations = annotations
-        return func
-    return decorator
-
-
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
@@ -837,25 +798,16 @@
     """
     
     @staticmethod
-    def _is_dbus_thing(thing):
-        """Returns a function testing if an attribute is a D-Bus thing
-        
-        If called like _is_dbus_thing("method") it returns a function
-        suitable for use as predicate to inspect.getmembers().
-        """
-        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
-                                   False)
+    def _is_dbus_property(obj):
+        return getattr(obj, "_dbus_is_property", False)
     
-    def _get_all_dbus_things(self, thing):
+    def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((getattr(athing.__get__(self), "_dbus_name",
-                         name),
-                 athing.__get__(self))
+        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, athing in
-                inspect.getmembers(cls,
-                                   self._is_dbus_thing(thing)))
+                for name, prop in
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
@@ -863,8 +815,7 @@
         """
         for cls in  self.__class__.__mro__:
             for name, value in (inspect.getmembers
-                                (cls,
-                                 self._is_dbus_thing("property"))):
+                                (cls, self._is_dbus_property)):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
@@ -912,7 +863,7 @@
         Note: Will not include properties with access="write".
         """
         properties = {}
-        for name, prop in self._get_all_dbus_things("property"):
+        for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
                 # Interface non-empty but did not match
@@ -933,9 +884,7 @@
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
-        """Overloading of standard D-Bus method.
-        
-        Inserts property tags and interface annotation tags.
+        """Standard D-Bus method, overloaded to insert property tags.
         """
         xmlstring = dbus.service.Object.Introspect(self, object_path,
                                                    connection)
@@ -948,44 +897,12 @@
                 e.setAttribute("access", prop._dbus_access)
                 return e
             for if_tag in document.getElementsByTagName("interface"):
-                # Add property tags
                 for tag in (make_tag(document, name, prop)
                             for name, prop
-                            in self._get_all_dbus_things("property")
+                            in self._get_all_dbus_properties()
                             if prop._dbus_interface
                             == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
-                # Add annotation tags
-                for typ in ("method", "signal", "property"):
-                    for tag in if_tag.getElementsByTagName(typ):
-                        annots = dict()
-                        for name, prop in (self.
-                                           _get_all_dbus_things(typ)):
-                            if (name == tag.getAttribute("name")
-                                and prop._dbus_interface
-                                == if_tag.getAttribute("name")):
-                                annots.update(getattr
-                                              (prop,
-                                               "_dbus_annotations",
-                                               {}))
-                        for name, value in annots.iteritems():
-                            ann_tag = document.createElement(
-                                "annotation")
-                            ann_tag.setAttribute("name", name)
-                            ann_tag.setAttribute("value", value)
-                            tag.appendChild(ann_tag)
-                # Add interface annotation tags
-                for annotation, value in dict(
-                    itertools.chain(
-                        *(annotations().iteritems()
-                          for name, annotations in
-                          self._get_all_dbus_things("interface")
-                          if name == if_tag.getAttribute("name")
-                          ))).iteritems():
-                    ann_tag = document.createElement("annotation")
-                    ann_tag.setAttribute("name", annotation)
-                    ann_tag.setAttribute("value", value)
-                    if_tag.appendChild(ann_tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
                 if (if_tag.getAttribute("name")
@@ -1006,7 +923,7 @@
         except (AttributeError, xml.dom.DOMException,
                 xml.parsers.expat.ExpatError) as error:
             logger.error("Failed to override Introspection method",
-                         exc_info=error)
+                         error)
         return xmlstring
 
 
@@ -1026,7 +943,6 @@
     def __new__(mcs, name, bases, attr):
         # Go through all the base classes which could have D-Bus
         # methods, signals, or properties in them
-        old_interface_names = []
         for base in (b for b in bases
                      if issubclass(b, dbus.service.Object)):
             # Go though all attributes of the base class
@@ -1042,8 +958,6 @@
                 alt_interface = (attribute._dbus_interface
                                  .replace("se.recompile.Mandos",
                                           "se.bsnet.fukt.Mandos"))
-                if alt_interface != attribute._dbus_interface:
-                    old_interface_names.append(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
                     # Extract the original non-method function by
@@ -1064,12 +978,6 @@
                                 nonmethod_func.func_name,
                                 nonmethod_func.func_defaults,
                                 nonmethod_func.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        new_function._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
                     # Define a creator of a function to call both the
                     # old and new functions, so both the old and new
                     # signals gets sent when the function is called
@@ -1103,12 +1011,6 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
                 # Is this a D-Bus property?
                 elif getattr(attribute, "_dbus_is_property", False):
                     # Create a new, but exactly alike, function
@@ -1128,38 +1030,6 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-                    # Copy annotations, if any
-                    try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
-                    except AttributeError:
-                        pass
-                # Is this a D-Bus interface?
-                elif getattr(attribute, "_dbus_is_interface", False):
-                    # Create a new, but exactly alike, function
-                    # object.  Decorate it to be a new D-Bus interface
-                    # with the alternate D-Bus interface name.  Add it
-                    # to the class.
-                    attr[attrname] = (dbus_interface_annotations
-                                      (alt_interface)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
-        # Deprecate all old interfaces
-        basename="_AlternateDBusNamesMetaclass_interface_annotation{0}"
-        for old_interface_name in old_interface_names:
-            @dbus_interface_annotations(old_interface_name)
-            def func(self):
-                return { "org.freedesktop.DBus.Deprecated": "true" }
-            # Find an unused name
-            for aname in (basename.format(i) for i in
-                          itertools.count()):
-                if aname not in attr:
-                    attr[aname] = func
-                    break
         return type.__new__(mcs, name, bases, attr)
 
 
@@ -1179,6 +1049,9 @@
     def __init__(self, bus = None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
+        self._approvals_pending = 0
+        
+        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1230,8 +1103,6 @@
                                        checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_checker_status = notifychangeproperty(dbus.Int16,
-                                               "LastCheckerStatus")
     last_approval_request = notifychangeproperty(
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
@@ -1315,13 +1186,6 @@
     ## D-Bus methods, signals & properties
     _interface = "se.recompile.Mandos.Client"
     
-    ## Interfaces
-    
-    @dbus_interface_annotations(_interface)
-    def _foo(self):
-        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                     "false"}
-    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1363,6 +1227,14 @@
         "D-Bus signal"
         return self.need_approval()
     
+    # NeRwequest - signal
+    @dbus.service.signal(_interface, signature="s")
+    def NewRequest(self, ip):
+        """D-Bus signal
+        Is sent after a client request a password.
+        """
+        pass
+    
     ## Methods
     
     # Approve - method
@@ -1478,12 +1350,6 @@
             return
         return datetime_to_dbus(self.last_checked_ok)
     
-    # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n",
-                           access="read")
-    def LastCheckerStatus_dbus_property(self):
-        return dbus.Int16(self.last_checker_status)
-    
     # Expires - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Expires_dbus_property(self):
@@ -1681,6 +1547,10 @@
                 except KeyError:
                     return
                 
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
+                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1750,7 +1620,7 @@
                 
                 logger.info("Sending secret to %s", client.name)
                 # bump the timeout using extended_timeout
-                client.bump_timeout(client.extended_timeout)
+                client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -2079,8 +1949,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {0!r}"
-                                 .format(suffix))
+                raise ValueError("Unknown suffix %r" % suffix)
         except (ValueError, IndexError) as e:
             raise ValueError(*(e.args))
         timevalue += delta
@@ -2100,11 +1969,11 @@
         sys.exit()
     if not noclose:
         # Close all standard open file descriptors
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          "{0} not a character device"
-                          .format(os.devnull))
+                          "%s not a character device"
+                          % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -2119,7 +1988,7 @@
     
     parser = argparse.ArgumentParser()
     parser.add_argument("-v", "--version", action="version",
-                        version = "%(prog)s {0}".format(version),
+                        version = "%%(prog)s %s" % version,
                         help="show version number and exit")
     parser.add_argument("-i", "--interface", metavar="IF",
                         help="Bind to interface IF")
@@ -2228,10 +2097,9 @@
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({0}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(server_settings
-                                        ["servicename"])))
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % server_settings["servicename"]))
     
     # Parse config file with clients
     client_config = configparser.SafeConfigParser(Client
@@ -2258,16 +2126,20 @@
         except IOError:
             logger.error("Could not open file %r", pidfilename)
     
-    for name in ("_mandos", "mandos", "nobody"):
+    try:
+        uid = pwd.getpwnam("_mandos").pw_uid
+        gid = pwd.getpwnam("_mandos").pw_gid
+    except KeyError:
         try:
-            uid = pwd.getpwnam(name).pw_uid
-            gid = pwd.getpwnam(name).pw_gid
-            break
+            uid = pwd.getpwnam("mandos").pw_uid
+            gid = pwd.getpwnam("mandos").pw_gid
         except KeyError:
-            continue
-    else:
-        uid = 65534
-        gid = 65534
+            try:
+                uid = pwd.getpwnam("nobody").pw_uid
+                gid = pwd.getpwnam("nobody").pw_gid
+            except KeyError:
+                uid = 65534
+                gid = 65534
     try:
         os.setgid(gid)
         os.setuid(uid)
@@ -2290,7 +2162,7 @@
          .gnutls_global_set_log_function(debug_gnutls))
         
         # Redirect stdin so all checkers get /dev/null
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
@@ -2304,7 +2176,7 @@
     
     global main_loop
     # From the Avahi example code
-    DBusGMainLoop(set_as_default=True)
+    DBusGMainLoop(set_as_default=True )
     main_loop = gobject.MainLoop()
     bus = dbus.SystemBus()
     # End of Avahi example code
@@ -2378,22 +2250,21 @@
             
             # Clients who has passed its expire date can still be
             # enabled if its last checker was successful.  Clients
-            # whose checker succeeded before we stored its state is
-            # assumed to have successfully run all checkers during
-            # downtime.
+            # whose checker failed before we stored its state is
+            # assumed to have failed all checkers during downtime.
             if client["enabled"]:
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
                             "disabling client {0} - Client never "
-                            "performed a successful checker"
-                            .format(client_name))
+                            "performed a successfull checker"
+                            .format(client["name"]))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
                             "disabling client {0} - Client "
                             "last checker failed with error code {1}"
-                            .format(client_name,
+                            .format(client["name"],
                                     client["last_checker_status"]))
                         client["enabled"] = False
                     else:
@@ -2402,7 +2273,7 @@
                                              + client["timeout"])
                         logger.debug("Last checker succeeded,"
                                      " keeping {0} enabled"
-                                     .format(client_name))
+                                     .format(client["name"]))
             try:
                 client["secret"] = (
                     pgp.decrypt(client["encrypted_secret"],
@@ -2424,7 +2295,7 @@
                         - set(old_client_settings)):
         clients_data[client_name] = client_settings[client_name]
 
-    # Create all client objects
+    # Create clients all clients
     for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client)
@@ -2451,18 +2322,12 @@
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        class MandosDBusService(DBusObjectWithProperties):
+        class MandosDBusService(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
             _interface = "se.recompile.Mandos"
             
-            @dbus_interface_annotations(_interface)
-            def _foo(self):
-                return { "org.freedesktop.DBus.Property"
-                         ".EmitsChangedSignal":
-                             "false"}
-            
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
@@ -2601,11 +2466,11 @@
     service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
-                    " flowinfo %d, scope_id %d",
-                    *tcp_server.socket.getsockname())
+                    " flowinfo %d, scope_id %d"
+                    % tcp_server.socket.getsockname())
     else:                       # IPv4
-        logger.info("Now listening on address %r, port %d",
-                    *tcp_server.socket.getsockname())
+        logger.info("Now listening on address %r, port %d"
+                    % tcp_server.socket.getsockname())
     
     #service.interface = tcp_server.socket.getsockname()[3]
     
@@ -2614,7 +2479,7 @@
         try:
             service.activate()
         except dbus.exceptions.DBusException as error:
-            logger.critical("D-Bus Exception", exc_info=error)
+            logger.critical("DBusException: %s", error)
             cleanup()
             sys.exit(1)
         # End of Avahi example code
@@ -2627,7 +2492,7 @@
         logger.debug("Starting main loop")
         main_loop.run()
     except AvahiError as error:
-        logger.critical("Avahi Error", exc_info=error)
+        logger.critical("AvahiError: %s", error)
         cleanup()
         sys.exit(1)
     except KeyboardInterrupt:

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-05-05 08:53:14 +0000
+++ mandos-ctl	2012-01-01 01:16:15 +0000
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.3"
+version = "1.4.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -70,12 +70,12 @@
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{0}T".format(td.days) if td.days else "",
-                    hours = td.seconds // 3600,
-                    minutes = (td.seconds % 3600) // 60,
-                    seconds = td.seconds % 60,
-                    ))
+    return ("%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+            % { "days": "%dT" % td.days if td.days else "",
+                "hours": td.seconds // 3600,
+                "minutes": (td.seconds % 3600) // 60,
+                "seconds": td.seconds % 60,
+                })
 
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
@@ -121,20 +121,18 @@
         return unicode(value)
     
     # Create format string to print table rows
-    format_string = " ".join("{{{key}:{width}}}".format(
-            width = max(len(tablewords[key]),
-                        max(len(valuetostring(client[key],
-                                              key))
-                            for client in
-                            clients)),
-            key = key) for key in keywords)
+    format_string = " ".join("%%-%ds" %
+                             max(len(tablewords[key]),
+                                 max(len(valuetostring(client[key],
+                                                       key))
+                                     for client in
+                                     clients))
+                             for key in keywords)
     # Print header line
-    print(format_string.format(**tablewords))
+    print(format_string % tuple(tablewords[key] for key in keywords))
     for client in clients:
-        print(format_string.format(**dict((key,
-                                           valuetostring(client[key],
-                                                         key))
-                                          for key in keywords)))
+        print(format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords))
 
 def has_actions(options):
     return any((options.enable,
@@ -159,7 +157,7 @@
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
-                        version = "%(prog)s {0}".format(version),
+                        version = "%%prog %s" % version,
                         help="show version number and exit")
     parser.add_argument("-a", "--all", action="store_true",
                         help="Select all clients")
@@ -258,8 +256,8 @@
                     clients[client_objc] = client
                     break
             else:
-                print("Client not found on server: {0!r}"
-                      .format(name), file=sys.stderr)
+                print("Client not found on server: %r" % name,
+                      file=sys.stderr)
                 sys.exit(1)
     
     if not has_actions(options) and clients:
@@ -282,24 +280,15 @@
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:
-                client.Set(client_interface, "Enabled",
-                           dbus.Boolean(True),
-                           dbus_interface=dbus.PROPERTIES_IFACE)
+                client.Enable(dbus_interface=client_interface)
             if options.disable:
-                client.Set(client_interface, "Enabled",
-                           dbus.Boolean(False),
-                           dbus_interface=dbus.PROPERTIES_IFACE)
+                client.Disable(dbus_interface=client_interface)
             if options.bump_timeout:
-                client.Set(client_interface, "LastCheckedOK", "",
-                           dbus_interface=dbus.PROPERTIES_IFACE)
+                client.CheckedOK(dbus_interface=client_interface)
             if options.start_checker:
-                client.Set(client_interface, "CheckerRunning",
-                           dbus.Boolean(True),
-                           dbus_interface=dbus.PROPERTIES_IFACE)
+                client.StartChecker(dbus_interface=client_interface)
             if options.stop_checker:
-                client.Set(client_interface, "CheckerRunning",
-                           dbus.Boolean(False),
-                           dbus_interface=dbus.PROPERTIES_IFACE)
+                client.StopChecker(dbus_interface=client_interface)
             if options.is_enabled:
                 sys.exit(0 if client.Get(client_interface,
                                          "Enabled",

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-01-15 21:07:44 +0000
+++ mandos-keygen	2011-12-31 23:05:34 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.3"
+VERSION="1.4.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-05-03 18:51:48 +0000
+++ mandos-monitor	2011-12-31 23:05:34 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.3"
+version = "1.4.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -131,6 +131,7 @@
         
         self._update_timer_callback_tag = None
         self._update_timer_callback_lock = 0
+        self.last_checker_failed = False
         
         # The widget shown normally
         self._text_widget = urwid.Text("")
@@ -144,8 +145,17 @@
         
         last_checked_ok = isoformat_to_datetime(self.properties
                                                 ["LastCheckedOK"])
+        if last_checked_ok is None:
+            self.last_checker_failed = True
+        else:
+            self.last_checker_failed = ((datetime.datetime.utcnow()
+                                         - last_checked_ok)
+                                        > datetime.timedelta
+                                        (milliseconds=
+                                         self.properties
+                                         ["Interval"]))
         
-        if self.properties ["LastCheckerStatus"] != 0:
+        if self.last_checker_failed:
             self.using_timer(True)
         
         if self.need_approval:
@@ -172,20 +182,14 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        #self.logger('Created client {0}'
-        #            .format(self.properties["Name"]))
+        #self.logger('Created client %s' % (self.properties["Name"]))
     
     def property_changed(self, property=None, value=None):
         super(self, MandosClientWidget).property_changed(property,
                                                          value)
         if property == "ApprovalPending":
             using_timer(bool(value))
-        if property == "LastCheckerStatus":
-            using_timer(value != 0)
-            #self.logger('Checker for client {0} (command "{1}") was '
-            #            ' successful'.format(self.properties["Name"],
-            #                                 command))
-    
+        
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
         activated or deactivated.
@@ -206,53 +210,61 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
+            if self.last_checker_failed:
+                self.last_checker_failed = False
+                self.using_timer(False)
+            #self.logger('Checker for client %s (command "%s")'
+            #            ' was successful'
+            #            % (self.properties["Name"], command))
             self.update()
             return
         # Checker failed
+        if not self.last_checker_failed:
+            self.last_checker_failed = True
+            self.using_timer(True)
         if os.WIFEXITED(condition):
-            self.logger('Checker for client {0} (command "{1}")'
-                        ' failed with exit code {2}'
-                        .format(self.properties["Name"], command,
-                                os.WEXITSTATUS(condition)))
+            self.logger('Checker for client %s (command "%s")'
+                        ' failed with exit code %s'
+                        % (self.properties["Name"], command,
+                           os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client {0} (command "{1}") was'
-                        ' killed by signal {2}'
-                        .format(self.properties["Name"], command,
-                                os.WTERMSIG(condition)))
+            self.logger('Checker for client %s (command "%s")'
+                        ' was killed by signal %s'
+                        % (self.properties["Name"], command,
+                           os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client {0} (command "{1}")'
+            self.logger('Checker for client %s (command "%s")'
                         ' dumped core'
-                        .format(self.properties["Name"], command))
+                        % (self.properties["Name"], command))
         else:
-            self.logger('Checker for client {0} completed'
-                        ' mysteriously'
-                        .format(self.properties["Name"]))
+            self.logger('Checker for client %s completed'
+                        ' mysteriously')
         self.update()
     
     def checker_started(self, command):
         """Server signals that a checker started. This could be useful
            to log in the future. """
-        #self.logger('Client {0} started checker "{1}"'
-        #            .format(self.properties["Name"],
-        #                    unicode(command)))
+        #self.logger('Client %s started checker "%s"'
+        #            % (self.properties["Name"], unicode(command)))
         pass
     
     def got_secret(self):
-        self.logger('Client {0} received its secret'
-                    .format(self.properties["Name"]))
+        self.last_checker_failed = False
+        self.logger('Client %s received its secret'
+                    % self.properties["Name"])
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {0} needs approval within {1} seconds'
+            message = 'Client %s needs approval within %s seconds'
         else:
-            message = 'Client {0} will get its secret in {1} seconds'
-        self.logger(message.format(self.properties["Name"],
-                                   timeout/1000))
+            message = 'Client %s will get its secret in %s seconds'
+        self.logger(message
+                    % (self.properties["Name"], timeout/1000))
         self.using_timer(True)
     
     def rejected(self, reason):
-        self.logger('Client {0} was rejected; reason: {1}'
-                    .format(self.properties["Name"], reason))
+        self.logger('Client %s was rejected; reason: %s'
+                    % (self.properties["Name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
@@ -284,7 +296,8 @@
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = '{name}: '.format(name=self.properties["Name"])
+        base = ('%(name)s: '
+                      % {"name": self.properties["Name"]})
         if not self.properties["Enabled"]:
             message = "DISABLED"
         elif self.properties["ApprovalPending"]:
@@ -299,11 +312,11 @@
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
-                message = "Approval in {0}. (d)eny?"
+                message = "Approval in %s. (d)eny?"
             else:
-                message = "Denial in {0}. (a)pprove?"
-            message = message.format(unicode(timer).rsplit(".", 1)[0])
-        elif self.properties["LastCheckerStatus"] != 0:
+                message = "Denial in %s. (a)pprove?"
+            message = message % unicode(timer).rsplit(".", 1)[0]
+        elif self.last_checker_failed:
             # When checker has failed, print a timer until client expires
             expires = self.properties["Expires"]
             if expires == "":
@@ -313,11 +326,11 @@
                                                      '%Y-%m-%dT%H:%M:%S.%f')
                 timer = expires - datetime.datetime.utcnow()
             message = ('A checker has failed! Time until client'
-                       ' gets disabled: {0}'
-                       .format(unicode(timer).rsplit(".", 1)[0]))
+                       ' gets disabled: %s'
+                           % unicode(timer).rsplit(".", 1)[0])
         else:
             message = "enabled"
-        self._text = "{0}{1}".format(base, message)
+        self._text = "%s%s" % (base, message)
             
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
@@ -488,9 +501,9 @@
         self.main_loop = gobject.MainLoop()
     
     def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {0} and fingerprint"
-                         " {1} could not be found"
-                         .format(address, fingerprint))
+        self.log_message(("Client with address %s and fingerprint %s"
+                          " could not be found" % (address,
+                                                    fingerprint)))
     
     def rebuild(self):
         """This rebuilds the User Interface.
@@ -549,8 +562,8 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {0!r} ({1!r}) removed"
-                             .format(name, path))
+            self.log_message("Unknown client %r (%r) removed", name,
+                             path)
             return
         client.delete()
     

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-01-15 21:07:44 +0000
+++ mandos.lsm	2011-10-15 16:48:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.3
-Entered-date:	2012-01-15
+Version:	1.4.1
+Entered-date:	2011-10-15
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      147K mandos_1.5.3.orig.tar.gz
+	      138K mandos_1.4.1.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		147K mandos_1.5.3.orig.tar.gz
+		138K mandos_1.4.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-01-15 21:01:13 +0000
+++ mandos.xml	2012-01-01 04:02:00 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-01-15">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -381,7 +381,9 @@
       extended timeout, checker program, and interval between checks
       can be configured both globally and per client; see
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.
+      <manvolnum>5</manvolnum></citerefentry>.  A client successfully
+      receiving its password will also be treated as a successful
+      checker run.
     </para>
   </refsect1>
   

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2012-04-24 06:55:34 +0000
+++ network-hooks.d/bridge	2011-12-31 14:05:57 +0000
@@ -6,9 +6,6 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012 Teddy Hogeborn
-# Copyright © 2012 Björn Påhlsson
-# 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
 # notice and this notice are preserved.  This file is offered as-is,
@@ -20,7 +17,7 @@
 
 addrtoif(){
     grep -liFe "$1" /sys/class/net/*/address \
-	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,' -e "/^${BRIDGE}\$/d"
+	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
 }
 
 # Read config file, which must set "BRIDGE", "PORT_ADDRESSES", and
@@ -37,48 +34,42 @@
     exit
 fi
 
-brctl="/sbin/brctl"
-for b in "$brctl" /usr/sbin/brctl; do
+for b in /sbin/brctl /usr/sbin/brctl; do
     if [ -e "$b" ]; then
 	brctl="$b"
 	break
     fi
 done
 
-do_start(){
-    "$brctl" addbr "$BRIDGE"
-    for address in $PORT_ADDRESSES; do
-	interface=`addrtoif "$address"`
-	"$brctl" addif "$BRIDGE" "$interface"
-	ip link set dev "$interface" up
-    done
-    ip link set dev "$BRIDGE" up
-    sleep "${DELAY%%.*}"
-    if [ -n "$IPADDRS" ]; then
-        for ipaddr in $IPADDRS; do
-	    ip addr add "$ipaddr" dev "$BRIDGE"
-	done
-    fi
-    if [ -n "$ROUTES" ]; then
-        for route in $ROUTES; do
-	    ip route add "$route" dev "$BRIDGE"
-	done
-    fi
-}
-
-do_stop(){
-    ip link set dev "$BRIDGE" down
-    for address in $PORT_ADDRESSES; do
-	interface=`addrtoif "$address"`
-	ip link set dev "$interface" down
-	"$brctl" delif "$BRIDGE" "$interface"
-    done
-    "$brctl" delbr "$BRIDGE"
-}
-
-case "${MODE:-$1}" in
-    start|stop)
-	do_"${MODE:-$1}"
+case "$1" in
+    start)
+	"$brctl" addbr "$BRIDGE"
+	for address in $PORT_ADDRESSES; do
+	    interface=`addrtoif "$address"`
+	    "$brctl" addif "$BRIDGE" "$interface"
+	    ip link set dev "$interface" up
+	done
+	ip link set dev "$BRIDGE" up
+	sleep "$DELAY"
+	if [ -n "$IPADDRS" ]; then
+            for ipaddr in $IPADDRS; do
+		ip addr add "$ipaddr" dev "$BRIDGE"
+	    done
+	fi
+	if [ -n "$ROUTES" ]; then
+            for route in $ROUTES; do
+		ip route add "$route" dev "$BRIDGE"
+	    done
+	fi
+	;;
+    stop)
+	ip link set dev "$BRIDGE" down
+	for address in $PORT_ADDRESSES; do
+	    interface=`addrtoif "$address"`
+	    ip link set dev "$interface" down
+	    "$brctl" delif "$BRIDGE" "$interface"
+	done
+	"$brctl" delbr "$BRIDGE"
 	;;
     files)
 	echo /bin/ip

=== modified file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2012-04-24 06:55:34 +0000
+++ network-hooks.d/openvpn	2011-12-31 14:05:57 +0000
@@ -6,9 +6,6 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012 Teddy Hogeborn
-# Copyright © 2012 Björn Påhlsson
-# 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
 # notice and this notice are preserved.  This file is offered as-is,
@@ -37,22 +34,18 @@
 
 openvpn=/usr/sbin/openvpn
 
-do_start(){
-    "$openvpn" --cd "$MANDOSNETHOOKDIR" --daemon 'openvpn(Mandos)' \
-	--writepid "$PIDFILE" --config "$CONFIG"
-     sleep "$DELAY"
-}
-
-do_stop(){
-    PID="`cat \"$PIDFILE\"`"
-    if [ "$PID" -gt 0 ]; then
-	kill "$PID"
-    fi
-}
-
-case "${MODE:-$1}" in
-    start|stop)
-	do_"${MODE:-$1}"
+case "$1" in
+    start)
+	"$openvpn" --cd "$MANDOSNETHOOKDIR" \
+	    --daemon 'openvpn(Mandos)' --writepid "$PIDFILE" \
+	    --config "$CONFIG"
+	sleep "$DELAY"
+	;;
+    stop)
+	PID="`cat \"$PIDFILE\"`"
+	if [ "$PID" -gt 0 ]; then
+	    kill "$PID"
+	fi
 	;;
     files)
 	echo "$openvpn"

=== modified file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2012-04-24 06:55:34 +0000
+++ network-hooks.d/wireless	2011-12-31 14:05:57 +0000
@@ -6,9 +6,6 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012 Teddy Hogeborn
-# Copyright © 2012 Björn Påhlsson
-# 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
 # notice and this notice are preserved.  This file is offered as-is,
@@ -73,81 +70,77 @@
     WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
 fi
 
-do_start(){
-    mkdir -m u=rwx,go= -p "$CTRLDIR"
-    "$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
-    for KEY in $ifkeys; do
-	ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	INTERFACE=`addrtoif "$ADDRESS"`
-	DRIVER=`eval 'echo "$WPA_DRIVER_'"$KEY"\"`
-	IFDELAY=`eval 'echo "$DELAY_'"$KEY"\"`
-	"$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
-	    "${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
-	    | sed -e '/^OK$/d'
-        NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" add_network`
-	eval wpa_interface_"$KEY"
-	"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
-	    "$NETWORK" | sed -e '/^OK$/d'
-	sleep "${IFDELAY:-$DELAY}" &
-	sleep=$!
-	while :; do
-	    kill -0 $sleep 2>/dev/null || break
-	    STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" status \
-		| sed -n -e 's/^wpa_state=//p'`
-	    if [ "$STATE" = COMPLETED ]; then
-		while :; do
-		    kill -0 $sleep 2>/dev/null || break 2
-		    UP=`cat /sys/class/net/"$INTERFACE"/operstate`
-		    if [ "$UP" = up ]; then
-			kill $sleep 2>/dev/null
-			break 2
-		    fi
-		    sleep 1
-		done
-	    fi
-	    sleep 1
-	done &
-	wait $sleep || :
-	IPADDRS=`eval 'echo "$IPADDRS_'"$KEY"\"`
-	if [ -n "$IPADDRS" ]; then
-	    if [ "$IPADDRS" = dhcp ]; then
-		ipconfig -c dhcp -d "$INTERFACE" || :
-		#dhclient "$INTERFACE"
-	    else
-		for ipaddr in $IPADDRS; do
-		    "$ip" addr add "$ipaddr" dev "$INTERFACE"
-		done
-	    fi
-	fi
-	ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
-	if [ -n "$ROUTES" ]; then
-	    for route in $ROUTES; do
-		"$ip" route add "$route" dev "$BRIDGE"
-	    done
-	fi
-    done
-}
-
-do_stop(){
-    "$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
-    for KEY in $ifkeys; do
-	ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	INTERFACE=`addrtoif "$ADDRESS"`
-	"$ip" addr show scope global permanent dev "$INTERFACE" \
-	    | while read type addr rest; do
+case "${MODE:-$1}" in
+    start)
+	mkdir -m u=rwx,go= -p "$CTRLDIR"
+	"$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
+        for KEY in $ifkeys; do
+	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
+	    INTERFACE=`addrtoif "$ADDRESS"`
+	    DRIVER=`eval 'echo "$WPA_DRIVER_'"$KEY"\"`
+	    IFDELAY=`eval 'echo "$DELAY_'"$KEY"\"`
+	    "$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
+		"${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
+		| sed -e '/^OK$/d'
+	    NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" \
+		add_network`
+	    eval wpa_interface_"$KEY"
+	    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
+		"$NETWORK" | sed -e '/^OK$/d'
+	    sleep "${IFDELAY:-$DELAY}" &
+	    sleep=$!
+	    while :; do
+		kill -0 $sleep 2>/dev/null || break
+		STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" \
+		    status | sed -n -e 's/^wpa_state=//p'`
+		if [ "$STATE" = COMPLETED ]; then
+		    while :; do
+			kill -0 $sleep 2>/dev/null || break 2
+			UP=`cat /sys/class/net/"$INTERFACE"/operstate`
+			if [ "$UP" = up ]; then
+			    kill $sleep 2>/dev/null
+			    break 2
+			fi
+			sleep 1
+		    done
+		fi
+		sleep 1
+	    done &
+	    wait $sleep || :
+	    IPADDRS=`eval 'echo "$IPADDRS_'"$KEY"\"`
+	    if [ -n "$IPADDRS" ]; then
+		if [ "$IPADDRS" = dhcp ]; then
+		    ipconfig -c dhcp -d "$INTERFACE" || :
+		    #dhclient "$INTERFACE"
+		else
+		    for ipaddr in $IPADDRS; do
+			"$ip" addr add "$ipaddr" dev "$INTERFACE"
+		    done
+		fi
+	    fi
+	    ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
+	    if [ -n "$ROUTES" ]; then
+		for route in $ROUTES; do
+		    "$ip" route add "$route" dev "$BRIDGE"
+		done
+	    fi
+        done
+	;;
+    stop)
+	"$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
+        for KEY in $ifkeys; do
+	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
+	    INTERFACE=`addrtoif "$ADDRESS"`
+	    "$ip" addr show scope global permanent dev "$INTERFACE" \
+		| while read type addr rest; do
 		case "$type" in
 		    inet|inet6)
 			"$ip" addr del "$addr" dev "$INTERFACE"
 			;;
 		esac
 	    done
-	"$ip" link set dev "$INTERFACE" down
-    done
-}
-
-case "${MODE:-$1}" in
-    start|stop)
-	do_"${MODE:-$1}"
+	    "$ip" link set dev "$INTERFACE" down
+	done
 	;;
     files)
 	echo "$wpa_supplicant"

